package com.eksad.masterdata.common.sample;

import java.util.Arrays;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Component;

/**
 *
 * @author hello world
 */
@Component
public class RequestUtil {

    @Value("${dam.portal.h2.token}")
    private String PORTAL_TOKEN;
    @Value("${dam.token.key.path}")
    private String TOKEN;

    private static final String HEADER_KEY      = "Authorization";

    public HttpEntity<String> getPortalPreFormattedRequestWithToken(){
        HttpHeaders httpHeaders       = new HttpHeaders();
        httpHeaders.setContentType(MediaType.APPLICATION_JSON);
        httpHeaders.setAccept(Arrays.asList(MediaType.APPLICATION_JSON, MediaType.TEXT_HTML));
        httpHeaders.add("Authorization", PORTAL_TOKEN);
        return new HttpEntity<>(httpHeaders);
    }

    public HttpEntity<String> getPreFormattedRequestWithToken(){
        HttpHeaders httpHeaders       = new HttpHeaders();
        httpHeaders.setContentType(MediaType.APPLICATION_JSON);
        httpHeaders.setAccept(Arrays.asList(MediaType.APPLICATION_JSON));
        httpHeaders.add(HEADER_KEY,TOKEN);

        return new HttpEntity<>(httpHeaders);
    }

    public HttpEntity<String> getPortalPreFormattedRequestWithRequestedToken(String token){
        HttpHeaders httpHeaders       = new HttpHeaders();
        httpHeaders.setContentType(MediaType.APPLICATION_JSON);
        httpHeaders.setAccept(Arrays.asList(MediaType.APPLICATION_JSON));
        httpHeaders.add(HEADER_KEY,token);

        return new HttpEntity<>(httpHeaders);
    }

    public HttpEntity<String> getPortalPreFormattedRequestDAWWithRequestedToken(String token){
        HttpHeaders httpHeaders       = new HttpHeaders();
        httpHeaders.setContentType(MediaType.APPLICATION_FORM_URLENCODED);
        httpHeaders.setAccept(Arrays.asList(MediaType.ALL));
        httpHeaders.add(HEADER_KEY,token);

        return new HttpEntity<>(httpHeaders);
    }
}
